﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

namespace TFC.PublicLighting.Contracts.DTOs
{
    using System;
    using System.Runtime.Serialization;
    using System.Collections.Generic;

    /// <summary>
    /// Representa una Ordre de Reparació
    /// </summary>
    [DataContract]
    public class OrdreDTO
    {
        #region Constructors
        public OrdreDTO()
        {
            this.IncidenciesList = new List<IncidenciaDTO>();
        }
        #endregion

        /// <summary>
        /// Identificació de la Ordre de Reparació a la BBDD
        /// </summary>
        [DataMember]
        public int Id_ordreReparacio { get; set; }

        [DataMember]
        public DateTime DataCreacio { get; set; }

        [DataMember]
        public string Id_tipusPrioritat { get; set; }

        [DataMember]
        public int Id_estatOrdre { get; set; }

        [DataMember]
        public EstatOrdreDTO Estat { get; set; }

        [DataMember]
        public DateTime DataResolucio { get; set; }

        [DataMember]
        public string ComentariSupervisor { get; set; }

        [DataMember]
        public string ComentariTecnic { get; set; }

        [DataMember]
        public int Id_supervisor { get; set; }

        [DataMember]
        public int Id_tecnic { get; set; }

        [DataMember]
        public List<IncidenciaDTO> IncidenciesList { get; set; }
    }
}

