﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

namespace TFC.PublicLighting.DistServices
{
    using System.Collections.Generic;
    using System.ServiceModel;
    using TFC.PublicLighting.Contracts.DTOs;

    [ServiceContract]
    public interface IPLManagementService
    {
        // Llistes per a selecionar a les vistes.
        # region Llistes Vistes

        [OperationContract]
        List<SectorDTO> GetAllSectors();

        [OperationContract]
        List<TipusElementDTO> GetAllTipusElement();

        [OperationContract]
        List<TipusAvariaDTO> GetAllTipusAvaria();

        [OperationContract]
        List<EstatIncidenciaDTO> GetAllEstatsIncidencia();

        [OperationContract]
        List<TipusPrioritatDTO> GetAllTipusPrioritat();

        [OperationContract]
        List<EstatOrdreDTO> GetAllEstatsOrdre();

        # endregion

        // Gestió d'Usuaris
        # region Usuaris

        [OperationContract]
        UsuariDTO GetLoggedUser(string user, string password);
        
        [OperationContract]
        UsuariDTO GetTecnicById(int pId);

        [OperationContract]
        List<UsuariDTO> GetTecnicsByFilter(UsuariDTO tecnicFilter);

        [OperationContract]
        UsuariDTO GetSupervisor();

        [OperationContract]
        List<UsuariDTO> GetAllTecnics();

        [OperationContract]
        bool AddTecnic(UsuariDTO pTecnic, int usuariDades);

        [OperationContract]
        bool AddSupervisor(UsuariDTO pSupervisor, int usuariDades);

        [OperationContract]
        bool UpdateSupervisor(UsuariDTO pSupervisor, int usuariDades);

        [OperationContract]
        bool UpdateTecnic(UsuariDTO pTecnic, int usuariDades);

        [OperationContract]
        bool DeleteTecnic(int pId, int usuariDades);

        [OperationContract]
        bool DeleteSupervisor(int pId, int usuariDades);

        # endregion

        // Gestió d'Elements
        # region Elements

        [OperationContract]
        ElementDTO GetElementById(int value);

        [OperationContract]
        List<ElementDTO> GetAllElements();

        [OperationContract]
        List<ElementDTO> GetElementsByFilter(ElementDTO elementFilter);

        [OperationContract]
        bool AddElement(ElementDTO pElement, int usuariDades);

        [OperationContract]
        bool UpdateElement(ElementDTO pId, int usuariDades);

        [OperationContract]
        bool DeleteElement(int pId, int usuariDades);

        # endregion

        // Gestió d'Incidències
        # region Incidencies

        [OperationContract]
        IncidenciaDTO GetIncidenciaById(int pId);

        [OperationContract]
        List<IncidenciaDTO> GetAllIncidencies();

        [OperationContract]
        List<IncidenciaDTO> GetIncidenciesByFilter(IncidenciaDTO incidenciaFilter);

        [OperationContract]
        bool AddIncidencia(IncidenciaDTO pIncidencia, int usuariDades);

        [OperationContract]
        bool UpdateIncidencia(IncidenciaDTO pIncidencia, int usuariDades);

        [OperationContract]
        bool DeleteIncidencia(int pId, int usuariDades);

        # endregion

        // Gestió d'Ordres de Reparacio
        # region Ordres

        [OperationContract]
        OrdreDTO GetOrdreById(int pId);

        [OperationContract]
        List<OrdreDTO> GetAllOrdres();

        [OperationContract]
        List<OrdreDTO> GetOrdresByFilter(OrdreDTO ordreFilter);

        [OperationContract]
        List<OrdreDTO> GetAllOrdresByTecnicId(int pIdTecnic);

        [OperationContract]
        bool AddOrdre(OrdreDTO pOrdre, int usuariDades);

        [OperationContract]
        bool UpdateOrdre(OrdreDTO pOrdre, int usuariDades);

        [OperationContract]
        bool UpdateListOrdres(List<OrdreDTO> pOrdreList, int usuariDades);

        [OperationContract]
        bool DeleteOrdre(int pId, int usuariDades);

        # endregion
    }
}
