﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

namespace TFC.PublicLighting.PresentationWPH7
{
    using System;
    using System.Windows;
    using Microsoft.Phone.Controls;
    using TFC.PublicLighting.PresentationWPH7.Cache;
    using TFC.PublicLighting.PresentationWPH7.WPhoneServiceReference;

    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void Loggin(object sender, RoutedEventArgs e)
        {
            // SERVEI CLIENT per interactuar amb els serveis distribuits.
            PLManagementServiceClient client = new PLManagementServiceClient();           

            // Validar password (entre 4 i 12 caràcters)
            bool isValidPassword = !(string.IsNullOrEmpty(PasswordBox.Password) || PasswordBox.Password.Length > 12 || PasswordBox.Password.Length < 4);

            // Validar usuari (entre 4 i 12 caràcters)
            bool isValidUser = !(string.IsNullOrEmpty(UserBox.Text) || UserBox.Text.Length > 12 || UserBox.Text.Length < 4);

            if (!isValidUser)
            {
                MessageBox.Show("Es requereix un nom d'usuari entre 4 i 12 caràcters");
            }
            else if (!isValidPassword)
            {
                MessageBox.Show("Es requereix una contrasenya entre 4 i 12 caràcters");
            }
            else
            {
                // Crida al servei per validar la identificació
                client.GetLoggedUserAsync(UserBox.Text, PasswordBox.Password);
                client.GetLoggedUserCompleted += new EventHandler<GetLoggedUserCompletedEventArgs>(client_GetLoggedUserCompleted);
            }
        }

        // Gestió del resultat de la identificació
        private void client_GetLoggedUserCompleted(object sender, GetLoggedUserCompletedEventArgs e)
        {
            UsuariDTO _loggedUser = e.Result;

            if (_loggedUser == null)
            {
                PasswordBox.Password = string.Empty;
                UserBox.Text = string.Empty;
                MessageBox.Show("Usuari no identificat");
            }
            else if (_loggedUser.IdTipusUsuari != "Tecnic")
            {
                PasswordBox.Password = string.Empty;
                UserBox.Text = string.Empty;
                MessageBox.Show("Usuari no autoritzat");
            }
            else
            {
                if (_loggedUser.IdTipusUsuari == "Tecnic")
                {
                    // Enregistrament de l'Id del tècnic al caché volàtil per fer servir durant la sessió.
                    CacheMain.CurrentUserId = _loggedUser.Id;

                    MessageBox.Show("Benvingut " + _loggedUser.Nom + " " + _loggedUser.Cognom1);
                    NavigationService.Navigate(new Uri("/Page_OrdresMain.xaml", UriKind.Relative));
                }
            }                        
        }
    }
}