﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

namespace TFC.PublicLighting.PresentationWPH7
{
    using System;
    using System.Windows;
    using Microsoft.Phone.Controls;
    using TFC.PublicLighting.PresentationWPH7.Cache;
    using TFC.PublicLighting.PresentationWPH7.MainServices;

    public partial class Page_OrdreEdit : PhoneApplicationPage
    {        
        public Page_OrdreEdit()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Page_OrdreEdit_Loaded);
        }

        void Page_OrdreEdit_Loaded(object sender, RoutedEventArgs e)
        {
            ContentPanel.DataContext = CacheMain.SelectedOrdre;
        }

        private void EstatOberta_Click(object sender, RoutedEventArgs e)
        {
            CacheMain.SelectedOrdre.Estat.Nom = "Oberta";
            CacheMain.SelectedOrdre.Estat.Id = 1;
            CacheMain.SelectedOrdre.Id_estatOrdre = 1;
        }

        private void EstatProces_Click(object sender, RoutedEventArgs e)
        {
            CacheMain.SelectedOrdre.Estat.Nom = "En procés";
            CacheMain.SelectedOrdre.Estat.Id = 2;
            CacheMain.SelectedOrdre.Id_estatOrdre = 3;
        }

        private void EstatTancada_Click(object sender, RoutedEventArgs e)
        {
            CacheMain.SelectedOrdre.Estat.Nom = "Tancada";
            CacheMain.SelectedOrdre.Estat.Id = 3;
            CacheMain.SelectedOrdre.Id_estatOrdre = 3;
        }

        private void ListIncidencies_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Page_IncidenciesList.xaml", UriKind.Relative));
        }

        protected override void OnNavigatingFrom(System.Windows.Navigation.NavigatingCancelEventArgs e)
        {
            base.OnNavigatingFrom(e);
            // Enregistrament a la memòria permanent isolatedStorage.
            LocalStorage.Store(CacheMain.OrdresList, CacheMain.FileStorageName);
        }
    }
}