﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

namespace TFC.PublicLighting.PresentationWPH7
{
    using System;
    using System.Collections.Generic;
    using System.Windows;
    using Microsoft.Phone.Controls;
    using TFC.PublicLighting.PresentationWPH7.Cache;
    using TFC.PublicLighting.PresentationWPH7.WPhoneServiceReference;

    public partial class Page_OrdresList : PhoneApplicationPage
    {
        public Page_OrdresList()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Page_OrdresList_Loaded);
        }

        List<OrdreDTO> ordresList;
        void Page_OrdresList_Loaded(object sender, RoutedEventArgs e)
        {
            ordresList = CacheMain.OrdresList;
            OrdresListListBox.ItemsSource = ordresList;
        }

        // Gestió de l'event de tocar y seleccionar una Ordre.
        private void OrdresListListBox_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            OrdreDTO mySelectedOrdre = OrdresListListBox.SelectedItem as OrdreDTO;
            
            // Preveu error si el casting falla.
            if (null != mySelectedOrdre)
            {
                CacheMain.SelectedOrdre = mySelectedOrdre;
                NavigationService.Navigate(new Uri("/Page_OrdreEdit.xaml", UriKind.Relative));
            }

            // Restableix l'índex seleccionat, de manera que l'usuari pot fer clic de nou, després de tornar.
            OrdresListListBox.SelectedIndex = -1;
        }
    }    
}