﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

namespace TFC.PublicLighting.Services.Mappers
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Data.Entity;
    using System.Text;
    using TFC.PublicLighting.Domain;
    using TFC.PublicLighting.Contracts.DTOs;
    
    // todo Resolver valores null
    public static class DTOMappers
    {        
        public static UsuariDTO UsuariToUsuariDTO (usuari pUsuari)
        {
            UsuariDTO usuariDTO = new UsuariDTO();

            if (pUsuari != null)
            {
                usuariDTO.Id = pUsuari.id_usuari;
                usuariDTO.Nom = pUsuari.nom;
                usuariDTO.Cognom1 = pUsuari.cognom1;
                usuariDTO.Cognom2 = pUsuari.cognom2;
                usuariDTO.TipusDocId = pUsuari.id_tipusDocument;
                usuariDTO.DocumentId = pUsuari.documentId;
                if (pUsuari.dataNeixement != null)
                {
                    usuariDTO.DataNeixement = (DateTime)pUsuari.dataNeixement;
                }                
                usuariDTO.Categoria = pUsuari.categoria;
                usuariDTO.Adreca = pUsuari.adreça;
                usuariDTO.Poblacio = pUsuari.poblacio;
                usuariDTO.CodiPostal = pUsuari.codiPostal;
                usuariDTO.Provincia = pUsuari.provincia;
                usuariDTO.TelefonPrivat = pUsuari.telefonPrivat;
                usuariDTO.TelefonOficina = pUsuari.telefonOficina;
                usuariDTO.MobilEmpresa = pUsuari.mobilEmpresa;
                usuariDTO.Email = pUsuari.email;
                usuariDTO.Usuari = pUsuari.nomUsuari;
                usuariDTO.IdTipusUsuari = pUsuari.id_tipusUsuari;
                usuariDTO.Contrasenya = pUsuari.clau;

                if (pUsuari.id_sector1.HasValue)
                {
                    usuariDTO.Sector1 = pUsuari.id_sector1.Value;
                }
                else
                {
                    usuariDTO.Sector1 = 0;
                }

                if (pUsuari.id_sector2.HasValue)
                {
                    usuariDTO.Sector2 = pUsuari.id_sector2.Value;
                }
                else
                {
                    usuariDTO.Sector2 = 0;
                }

                if (pUsuari.id_sector3.HasValue)
                {
                    usuariDTO.Sector3 = pUsuari.id_sector3.Value;
                }
                else
                {
                    usuariDTO.Sector3 = 0;
                }                
            }
            return usuariDTO;            
        }

        public static usuari UsuariDTOToUsuari(UsuariDTO usuariDTO)
        {
            usuari usuari = new usuari();

            if (usuariDTO != null)
            {
                usuari.id_usuari = usuariDTO.Id;
                usuari.nom = usuariDTO.Nom;
                usuari.cognom1 = usuariDTO.Cognom1;
                usuari.cognom2 = usuariDTO.Cognom2;
                usuari.id_tipusDocument = usuariDTO.TipusDocId;
                usuari.documentId = usuariDTO.DocumentId;
                usuari.dataNeixement = usuariDTO.DataNeixement;
                usuari.categoria = usuariDTO.Categoria;
                usuari.adreça = usuariDTO.Adreca;
                usuari.poblacio = usuariDTO.Poblacio;
                usuari.codiPostal = usuariDTO.CodiPostal;
                usuari.provincia = usuariDTO.Provincia;
                usuari.telefonPrivat = usuariDTO.TelefonPrivat;
                usuari.mobilEmpresa = usuariDTO.MobilEmpresa;
                usuari.email = usuariDTO.Email;
                usuari.nomUsuari = usuariDTO.Usuari;
                usuari.id_tipusUsuari = usuariDTO.IdTipusUsuari;
                usuari.clau = usuariDTO.Contrasenya;
                
                if (usuariDTO.Sector1 > 0)
                {
                    usuari.id_sector1 = usuariDTO.Sector1;
                }
                else
                {
                    usuari.id_sector1 = null;
                }

                if (usuariDTO.Sector2 > 0)
                {
                    usuari.id_sector2 = usuariDTO.Sector1;
                }
                else
                {
                    usuari.id_sector2 = null;
                }

                if (usuariDTO.Sector3 > 0)
                {
                    usuari.id_sector3 = usuariDTO.Sector1;
                }
                else
                {
                    usuari.id_sector3 = null;
                }                
            }            
            return usuari;
        }      
    }
}
