﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFC.PublicLighting.Contracts.DTOs;
using TFC.PublicLighting.Domain;

namespace TFC.PublicLighting.Services.Mappers
{
    public static class ElementsMapperExtensions
    {
        public static ElementDTO ToDTO(this elementEnllumenat elementDomain)
        {
            var elementDTO = new ElementDTO();

            if (elementDomain != null)
            {
                elementDTO.Carrer = elementDomain.carrer;
                elementDTO.CodiPostal = elementDomain.codiPostal;
                elementDTO.Fabricant = elementDomain.fabricant;
                elementDTO.Id = elementDomain.id_element;
                elementDTO.Id_sectorXarxa = elementDomain.id_sectorXarxa;
                elementDTO.Id_tipusElement = elementDomain.id_tipusElement;
                elementDTO.Matricula = elementDomain.matricula;
                elementDTO.NotesPosicio = elementDomain.notesPosicio;
                elementDTO.NumeroAproximat = elementDomain.numeroAproximat;
                elementDTO.PosicioLatitud = elementDomain.posicioLatitud;
                elementDTO.PosicioLongitud = elementDomain.posicioLongitud;
                elementDTO.Referencia = elementDomain.referencia;
            }

            return elementDTO;
        }

        public static elementEnllumenat ToDomain(this ElementDTO elementDTO)
        {
            var elementDomain = new elementEnllumenat();

            if (elementDTO != null)
            {
                elementDomain.carrer = elementDTO.Carrer;
                elementDomain.codiPostal = elementDTO.CodiPostal;
                elementDomain.fabricant = elementDTO.Fabricant;
                elementDomain.id_element = elementDTO.Id;
                elementDomain.id_sectorXarxa = elementDTO.Id_sectorXarxa;
                elementDomain.id_tipusElement = elementDTO.Id_tipusElement;
                elementDomain.matricula = elementDTO.Matricula;
                elementDomain.notesPosicio = elementDTO.NotesPosicio;
                elementDomain.numeroAproximat = elementDTO.NumeroAproximat;
                elementDomain.posicioLatitud = elementDTO.PosicioLatitud;
                elementDomain.posicioLongitud = elementDTO.PosicioLongitud;
                elementDomain.referencia = elementDTO.Referencia;
            }

            return elementDomain;
        }
    }
}
