﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFC.PublicLighting.Contracts.DTOs;
using TFC.PublicLighting.Domain;

namespace TFC.PublicLighting.Services.Mappers
{
    public static class IncidenciaMapperExtensions
    {
        public static IncidenciaDTO ToDTO(this incidencia domainObject)
        {
            var incidenciaDTO = new IncidenciaDTO();

            if (domainObject != null)
            {
                incidenciaDTO.Comentari = domainObject.comentari;
                incidenciaDTO.DataCreacio = domainObject.dataCreacio;
                incidenciaDTO.Id_element = domainObject.id_element;
                incidenciaDTO.Id_incidencia = domainObject.id_incidencia;
                incidenciaDTO.Id_supervisor = domainObject.id_supervisor;
                incidenciaDTO.Id_tipusAvaria = domainObject.id_tipusAvaria;
            }

            return incidenciaDTO;
        }

        public static incidencia ToDomain(this IncidenciaDTO incidenciaDTO)
        {
            var incidencia = new incidencia();

            if (incidenciaDTO != null)
            {
                incidencia.comentari = incidenciaDTO.Comentari;
                incidencia.dataCreacio = incidenciaDTO.DataCreacio;
                incidencia.id_element = incidenciaDTO.Id_element;
                incidencia.id_incidencia = incidenciaDTO.Id_incidencia;
                incidencia.id_supervisor = incidenciaDTO.Id_supervisor;
                incidencia.id_tipusAvaria = incidenciaDTO.Id_tipusAvaria;
            }

            return incidencia;
        }
    }
}
