﻿// --------------------------------------------------------------------------------------------------------------------
// Sistema Gestió Incidències Enllumenat Públic
// UOC. Treball de Fí de Carrera .NET
//
// Universitat Oberta de Catalunya, Gener 2012
// Toni Navarro Sánchez
// toninavarrosan@gmail.com
// --------------------------------------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TFC.PublicLighting.Contracts.DTOs;
using TFC.PublicLighting.Domain;

namespace TFC.PublicLighting.Services.Mappers
{
    public static class OrdreMapperExtensions
    {
        public static OrdreDTO ToDTO(this ordreReparacio domainObject)
        {
            var ordreDTO = new OrdreDTO();

            if (domainObject != null)
            {
                ordreDTO.ComentariSupervisor = domainObject.comentariSupervisor;
                ordreDTO.ComentariTecnic = domainObject.comentariTecnic;
                ordreDTO.DataCreacio = domainObject.dataCreacio;
                ordreDTO.DataResolucio = domainObject.dataResolucio.GetValueOrDefault(DateTime.MinValue);
                ordreDTO.Id_estatOrdre = domainObject.id_estatOrdre;
                ordreDTO.Id_ordreReparacio = domainObject.id_ordreReparacio;
                ordreDTO.Id_supervisor = domainObject.id_supervisor;
                ordreDTO.Id_tecnic = domainObject.id_tecnic;
                ordreDTO.Id_tipusPrioritat = domainObject.id_tipusPrioritat;
            }

            return ordreDTO;
        }

        public static ordreReparacio ToDomain(this OrdreDTO ordreDTO)
        {
            var domainObject = new ordreReparacio();

            if (ordreDTO != null)
            {
                domainObject.comentariSupervisor = ordreDTO.ComentariSupervisor;
                domainObject.comentariTecnic = ordreDTO.ComentariTecnic;
                domainObject.dataCreacio = ordreDTO.DataCreacio;
                if (ordreDTO.DataResolucio != DateTime.MinValue)
                {
                    domainObject.dataResolucio = ordreDTO.DataResolucio;
                }
                domainObject.id_estatOrdre = ordreDTO.Id_estatOrdre;
                domainObject.id_ordreReparacio = ordreDTO.Id_ordreReparacio;
                domainObject.id_supervisor = ordreDTO.Id_supervisor;
                domainObject.id_tecnic = ordreDTO.Id_tecnic;
                domainObject.id_tipusPrioritat = ordreDTO.Id_tipusPrioritat;
            }

            return domainObject;
        }
    }
}
